<#assign self_content>
    /**
     * 工具栏模型数据
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public linkModel:Array<any> = [];

    /**
     * 激活表单
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public activeForm:any = {};

    /**
     * 工作流附加功能类型映射关系对象
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base                
     */
    public wfAddiFeatureRef: any = {
        // 转办
        "reassign": { featureTag: "REASSIGN", action: "TransFerTask" },
        // 前加签
        "addstepbefore": { featureTag: "ADDSTEPBEFORE", action: "BeforeSign" },
        // 后加签
        "addstepafter": { featureTag: "ADDSTEPAFTER", action: "AfterSign" },
        // 回退
        "sendback": { featureTag: "SENDBACK", action: "SendBack" },
        // 抄送
        "sendcopy": { featureTag: "SENDCOPY", action: "sendCopy" },
        // 补充信息
        "supplyinfo": { featureTag: "SUPPLYINFO", action: "supplyInfo" },
        // 征求意见
        "takeadvice": { featureTag: "TAKEADVICE", action: "takeAdvice" }
    };

    /**
     * 所有表单数据
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public allForm: any = {
    <#if view.getAllPSControls?? && view.getAllPSControls()??>
    <#list view.getAllPSControls() as singleControl>
    <#if singleControl.getControlType?? && singleControl.getControlType()?? && singleControl.getControlType() != "TOOLBAR">
        "${singleControl.getName()}":{name:"view_${singleControl.getName()}",autosave:"${singleControl.isEnableAutoSave()?c}",showBusyIndicator:"${singleControl.isShowBusyIndicator()?c}",updateAction:"<#if singleControl.getUpdatePSControlAction()?? && singleControl.getUpdatePSControlAction().getPSAppDEMethod()??>${singleControl.getUpdatePSControlAction().getPSAppDEMethod().getCodeName()}</#if>",removeAction:"<#if singleControl.getRemovePSControlAction()?? && singleControl.getRemovePSControlAction().getPSAppDEMethod()??>${singleControl.getRemovePSControlAction().getPSAppDEMethod().getCodeName()}</#if>",loaddraftAction:"<#if singleControl.getGetDraftPSControlAction()?? && singleControl.getGetDraftPSControlAction().getPSAppDEMethod()??>${singleControl.getGetDraftPSControlAction().getPSAppDEMethod().getCodeName()}</#if>",loadAction:"<#if singleControl.getGetPSControlAction()?? && singleControl.getGetPSControlAction().getPSAppDEMethod()??>${singleControl.getGetPSControlAction().getPSAppDEMethod().getCodeName()}</#if>",createAction:"<#if singleControl.getCreatePSControlAction()?? && singleControl.getCreatePSControlAction().getPSAppDEMethod()??>${singleControl.getCreatePSControlAction().getPSAppDEMethod().getCodeName()}</#if>",WFSubmitAction:"<#if singleControl.getWFSubmitPSControlAction()?? && singleControl.getWFSubmitPSControlAction().getPSAppDEMethod()??>${singleControl.getWFSubmitPSControlAction().getPSAppDEMethod().getCodeName()}</#if>",WFStartAction:"<#if singleControl.getWFStartPSControlAction()?? && singleControl.getWFStartPSControlAction().getPSAppDEMethod()??>${singleControl.getWFStartPSControlAction().getPSAppDEMethod().getCodeName()}</#if>"}<#if singleControl_has_next>,</#if>
    </#if>
    </#list>
    </#if>
    };

    /**
     * 视图引用数据
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public viewRefData:any = {
    <#if view.getPSAppViewRefs?? && view.getPSAppViewRefs()??>
    <#list view.getPSAppViewRefs() as viewRef>
    <#if viewRef.getName?? && viewRef.getName()?? && viewRef.getRefPSAppView?? && viewRef.getRefPSAppView()??>
    <#assign refAppView = viewRef.getRefPSAppView() />
        "${viewRef.getName()}":{viewname:"${srffilepath2(refAppView.getCodeName())}",title:"<#if refAppView.getPSAppDataEntity()??>entities.${refAppView.getPSAppDataEntity().getCodeName()?lower_case}.views.${refAppView.getPSDEViewCodeName()?lower_case}.caption<#else>app.views.${refAppView.getCodeName()?lower_case}.caption</#if>", width: <#if refAppView.getWidth?? && refAppView.getWidth() gt 0>${refAppView.getWidth()?c}<#else>800</#if>, height: <#if refAppView.getHeight?? && refAppView.getHeight() gt 0>${refAppView.getHeight()?c}<#else>500</#if>}<#if viewRef_has_next>,</#if>
    </#if>
    </#list>
    </#if>
    };

    /**
     * 获取工具栏按钮
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public getWFLinkModel():Promise<any>{
        return new Promise((resolve:any, reject:any) =>{
            let datas: {} = {};
            if (Object.keys(this.viewparams).length > 0) {
                Object.assign(datas, { 'processDefinitionKey': this.viewparams.processDefinitionKey });
                Object.assign(datas, { 'taskDefinitionKey': this.viewparams.taskDefinitionKey || this.viewparams.userTaskId });
            }
            this.appEntityService.GetWFLink(JSON.parse(JSON.stringify(this.context)),datas,true).then((response:any) =>{
                if (response && response.status === 200) {
                    this.linkModel = response.data;
                    if(response.headers && response.headers['process-form']){
                        this.computeActivedForm(response.headers['process-form']);
                    }else{
                        this.computeActivedForm(null);
                    }
                    resolve(response.data);
                }
            }).catch((response: any) => {
                if (response && response.status) {
                    this.$Notice.error({ title: '错误', desc: response.message });
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    return;
                }
            });
        });
    }

    /**
     * 计算激活表单
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public computeActivedForm(inputForm:any){
        if(!inputForm){
            this.activeForm = this.allForm && Object.values(this.allForm)[0];
            return;
        }
        if(this.allForm && Object.keys(this.allForm).length >0){
            Object.keys(this.allForm).forEach((name:string) =>{
                <#noparse>if(Object.is(name,`wfform_${inputForm.toLowerCase()}`)){</#noparse>
                    this.activeForm = this.allForm[name];
                }
            })
        }
    }

    /**
     * 动态工具栏点击
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base
     */
    public dynamic_toolbar_click(linkItem:any, $event:any){
        let datas: any[] = [];
        let xData: any = this.$refs.form;
        if (xData.getDatas && xData.getDatas instanceof Function) {
            datas = [...xData.getDatas()];
        }
        const submit:Function = (submitData:any,linkItem:any) =>{
            xData.wfsubmit(submitData,linkItem).then((response: any) => {
                if (!response || response.status !== 200) {
                    return;
                }
                const { data: _data } = response;

                if (this.viewdata) {
                    this.$emit('viewdataschange', [{ ..._data }]);
                    this.$emit('close');
                } else if (this.$tabPageExp) {
                    this.$tabPageExp.onClose(this.$route.fullPath);
                }
            });
        }
        const submitAction: Function = () => {
            if (linkItem && linkItem.sequenceflowview && <#noparse>this.viewRefData[`WFACTION@${linkItem.sequenceflowview}`]</#noparse>) {
                let tempContext: any = Util.deepCopy(this.context);
                Object.assign(tempContext,{${appde.getCodeName()?lower_case}:datas && datas[0].srfkey});
                let tempViewParam: any = { actionView: linkItem.sequenceflowview, actionForm: linkItem.sequenceflowform };
                let targetView: any = <#noparse>this.viewRefData[`WFACTION@${linkItem.sequenceflowview}`]</#noparse>;
                const appmodal = this.$appmodal.openModal({ viewname: targetView.viewname, title: (this.$t(targetView.title) as string), height: targetView.height, width: targetView.width }, tempContext, tempViewParam);
                appmodal.subscribe((result: any) => {
                    if (!result || !Object.is(result.ret, 'OK')) {
                        return;
                    }
                    let tempSubmitData: any = Util.deepCopy(datas);
                    tempSubmitData.forEach((element: any) => {
                        Object.assign(element, result.datas && result.datas[0]);
                    });
                    submit(tempSubmitData, linkItem);
                });
            } else {
                submit(datas, linkItem);
            }
        }
        if (linkItem && linkItem.type) {
            if (Object.is(linkItem.type, "finish")) {
                submitAction();
            } else {
                this.handleWFAddiFeature(linkItem, datas);
            }
        } else {
            submitAction();
        } 
    }

    /**
     * 处理工作流辅助功能
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base                
     */
    public handleWFAddiFeature(linkItem: any, data: any) {
        if (linkItem.sequenceflowform) {
            let featureTag: string = this.wfAddiFeatureRef[linkItem.type].featureTag;
            if (!featureTag) return;
            <#noparse>let targetView: any = this.viewRefData[`WFUTILACTION@${featureTag}`];</#noparse>
            if (!targetView) {
                <#noparse>this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: `未找到${featureTag}映射视图` });</#noparse>
                return;
            }
            let tempContext: any = Util.deepCopy(this.context);
            Object.assign(tempContext,{${appde.getCodeName()?lower_case}:data && data[0].srfkey});
            let tempViewParam: any = { actionForm: linkItem.sequenceflowform };
            const appmodal = this.$appmodal.openModal({ viewname: targetView.viewname, title: (this.$t(targetView.title) as string), height: targetView.height, width: targetView.width }, tempContext, tempViewParam);
            appmodal.subscribe((result: any) => {
                if (!result || !Object.is(result.ret, 'OK')) {
                    return;
                }
                let tempSubmitData: any = Util.deepCopy(data[0]);
                if (result.datas && result.datas[0]) {
                    const resultData: any = result.datas[0];
                    if (Object.keys(resultData).length > 0) {
                        let tempData: any = {};
                        Object.keys(resultData).forEach((key: any) => {
                            if (resultData[key] && (key !== "srfuf")) tempData[key] = resultData[key];
                        })
                        Object.assign(tempSubmitData, tempData);
                    }
                    this.submitWFAddiFeature(linkItem, tempSubmitData);
                }
            });
        }else{
            this.submitWFAddiFeature(linkItem, data);
        }
    }

    /**
     * 提交工作流辅助功能
     * 
     * @memberof ${srfclassname('${view.codeName}')}Base                
     */
    public submitWFAddiFeature(linkItem: any, submitData: any) {
        const that: any = this;
        let tempSubmitData: any = Object.assign(linkItem, { "activedata": submitData });
        let action: string = this.wfAddiFeatureRef[linkItem.type].action;
        if (!action) return;
        if (that.appEntityService && that.appEntityService[action] && that.appEntityService[action] instanceof Function) {
            const tempContext = Util.deepCopy(this.context);
            Object.assign(tempContext, { taskId: linkItem.taskId })
            that.appEntityService[action](tempContext, tempSubmitData).then((response: any) => {
                const { data } = response;
                if (!response || response.status !== 200) {
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: data.message ? data.message : this.$t('app.commonWords.sysException') as string });
                    return;
                }
                if (this.viewdata) {
                    this.$emit('viewdataschange', [{ ...data }]);
                    this.$emit('close');
                } else if (this.$tabPageExp) {
                    this.$tabPageExp.onClose(this.$route.fullPath);
                }
                this.$Notice.success({ title: '', desc: (this.$t('app.formpage.workflow.submitsuccess') as string) });
            }).catch((error: any) => {
                const { data } = error;
                this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: data.message ? data.message : this.$t('app.commonWords.sysException') as string });
            })
        } else {
            <#noparse>this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: `${action}暂未实现` });</#noparse>
        }
    }

</#assign>
<#assign generateTip>
// 基于 @VIEW/实体工作流动态编辑视图/VIEW-BASE.vue.ftl 生成
</#assign>
<#ibizinclude>
../@MACRO/VIEW-BASE.vue.ftl
</#ibizinclude>